#!/bin/sh
set -eu

#region logging setup
if [ "${MISE_DEBUG-}" = "true" ] || [ "${MISE_DEBUG-}" = "1" ]; then
	debug() {
		echo "$@" >&2
	}
else
	debug() {
		:
	}
fi

if [ "${MISE_QUIET-}" = "1" ] || [ "${MISE_QUIET-}" = "true" ]; then
	info() {
		:
	}
else
	info() {
		echo "$@" >&2
	}
fi

error() {
	echo "$@" >&2
	exit 1
}
#endregion

#region environment setup
get_os() {
	os="$(uname -s)"
	if [ "$os" = Darwin ]; then
		echo "macos"
	elif [ "$os" = Linux ]; then
		echo "linux"
	else
		error "unsupported OS: $os"
	fi
}

get_arch() {
	musl=""
	if type ldd >/dev/null 2>/dev/null; then
		libc=$(ldd /bin/ls | grep 'musl' | head -1 | cut -d ' ' -f1)
		if [ -n "$libc" ]; then
			musl="-musl"
		fi
	fi
	arch="$(uname -m)"
	if [ "$arch" = x86_64 ]; then
		echo "x64$musl"
	elif [ "$arch" = aarch64 ] || [ "$arch" = arm64 ]; then
		echo "arm64$musl"
	elif [ "$arch" = armv7l ]; then
		echo "armv7$musl"
	else
		error "unsupported architecture: $arch"
	fi
}

shasum_bin() {
	if command -v shasum >/dev/null 2>&1; then
		echo "shasum"
	elif command -v sha256sum >/dev/null 2>&1; then
		echo "sha256sum"
	else
		error "mise install requires shasum or sha256sum but neither is installed. Aborting."
	fi
}

get_checksum() {
	version=$1
	os="$(get_os)"
	arch="$(get_arch)"
	url="https://github.com/jdx/mise/releases/download/${version}/SHASUMS256.txt"

	# For current version use static checksum otherwise
	# use checksum from releases
	if [ "$version" = "v2024.10.7" ]; then
		checksum_linux_x86_64="ce8c083abb36cf1f0cd85350e37e40e260ddd6c5db61255d7dab284d8cf75698  ./mise-v2024.10.7-linux-x64.tar.gz"
		checksum_linux_x86_64_musl="3d520b9b9815a48151f3650c71c8040e08452b0d52392f147388296263db4461  ./mise-v2024.10.7-linux-x64-musl.tar.gz"
		checksum_linux_arm64="cdc4d540b564b46f901c1ace11f0aab20b05c55faf9cedaf8ba5c117d11b856c  ./mise-v2024.10.7-linux-arm64.tar.gz"
		checksum_linux_arm64_musl="13ff1b8bbea0c6a40a570078696fd91cf63109b0e4cf19a85ed7e2b5fb55da50  ./mise-v2024.10.7-linux-arm64-musl.tar.gz"
		checksum_linux_armv7="a47fd09cccec9045c3c07a10c9b7d5c4ac9deeb173c4936f41fdd0c3d76840fa  ./mise-v2024.10.7-linux-armv7.tar.gz"
		checksum_linux_armv7_musl="7e7b97a500947cc95ab5ae025f0713ee768df4c3495d82495c6268ad3a5eac7c  ./mise-v2024.10.7-linux-armv7-musl.tar.gz"
		checksum_macos_x86_64="faad7f45defceb0c8b0280b04b14c806f1a89bef37de57beac60f4931820f9ac  ./mise-v2024.10.7-macos-x64.tar.gz"
		checksum_macos_arm64="e45de3aab649a6c637fee7d3170956b14ad000a853aa4e17bfb41f936104bd28  ./mise-v2024.10.7-macos-arm64.tar.gz"

		if [ "$os" = "linux" ]; then
			if [ "$arch" = "x64" ]; then
				echo "$checksum_linux_x86_64"
			elif [ "$arch" = "x64-musl" ]; then
				echo "$checksum_linux_x86_64_musl"
			elif [ "$arch" = "arm64" ]; then
				echo "$checksum_linux_arm64"
			elif [ "$arch" = "arm64-musl" ]; then
				echo "$checksum_linux_arm64_musl"
			elif [ "$arch" = "armv7" ]; then
				echo "$checksum_linux_armv7"
			elif [ "$arch" = "armv7-musl" ]; then
				echo "$checksum_linux_armv7_musl"
			else
				warn "no checksum for $os-$arch"
			fi
		elif [ "$os" = "macos" ]; then
			if [ "$arch" = "x64" ]; then
				echo "$checksum_macos_x86_64"
			elif [ "$arch" = "arm64" ]; then
				echo "$checksum_macos_arm64"
			else
				warn "no checksum for $os-$arch"
			fi
		else
			warn "no checksum for $os-$arch"
		fi
	else
		if command -v curl >/dev/null 2>&1; then
			debug ">" curl -fsSL "$url"
			checksums="$(curl -fsSL "$url")"
		else
			if command -v wget >/dev/null 2>&1; then
				debug ">" wget -qO - "$url"
				stderr=$(mktemp)
				checksums="$(wget -qO - "$url")"
			else
				error "mise standalone install specific version requires curl or wget but neither is installed. Aborting."
			fi
		fi

		checksum="$(echo "$checksums" | grep "$os-$arch.tar.gz")"
		if ! echo "$checksum" | grep -Eq "^([0-9a-f]{32}|[0-9a-f]{64})"; then
			warn "no checksum for mise $version and $os-$arch"
		else
			echo "$checksum"
		fi
	fi
}

#endregion

download_file() {
	url="$1"
	filename="$(basename "$url")"
	cache_dir="$(mktemp -d)"
	file="$cache_dir/$filename"

	info "mise: installing mise..."

	if command -v curl >/dev/null 2>&1; then
		debug ">" curl -#fLo "$file" "$url"
		curl -#fLo "$file" "$url"
	else
		if command -v wget >/dev/null 2>&1; then
			debug ">" wget -qO "$file" "$url"
			stderr=$(mktemp)
			wget -O "$file" "$url" >"$stderr" 2>&1 || error "wget failed: $(cat "$stderr")"
		else
			error "mise standalone install requires curl or wget but neither is installed. Aborting."
		fi
	fi

	echo "$file"
}

install_mise() {
	version="${MISE_VERSION:-v2024.10.7}"
	os="$(get_os)"
	arch="$(get_arch)"
	install_path="${MISE_INSTALL_PATH:-$HOME/.local/bin/mise}"
	install_dir="$(dirname "$install_path")"
	tarball_url="https://github.com/jdx/mise/releases/download/${version}/mise-${version}-${os}-${arch}.tar.gz"

	cache_file=$(download_file "$tarball_url")
	debug "mise-setup: tarball=$cache_file"

	debug "validating checksum"
	cd "$(dirname "$cache_file")" && get_checksum "$version" | "$(shasum_bin)" -c >/dev/null

	# extract tarball
	mkdir -p "$install_dir"
	rm -rf "$install_path"
	cd "$(mktemp -d)"
	tar -xzf "$cache_file"
	mv mise/bin/mise "$install_path"
	info "mise: installed successfully to $install_path"
}

after_finish_help() {
	case "${SHELL:-}" in
	*/zsh)
		info "mise: run the following to activate mise in your shell:"
		info "echo \"eval \\\"\\\$($install_path activate zsh)\\\"\" >> \"${ZDOTDIR-$HOME}/.zshrc\""
		info ""
		info "mise: this must be run in order to use mise in the terminal"
		info "mise: run \`mise doctor\` to verify this is setup correctly"
		;;
	*/bash)
		info "mise: run the following to activate mise in your shell:"
		info "echo \"eval \\\"\\\$($install_path activate bash)\\\"\" >> ~/.bashrc"
		info ""
		info "mise: this must be run in order to use mise in the terminal"
		info "mise: run \`mise doctor\` to verify this is setup correctly"
		;;
	*/fish)
		info "mise: run the following to activate mise in your shell:"
		info "echo \"$install_path activate fish | source\" >> ~/.config/fish/config.fish"
		info ""
		info "mise: this must be run in order to use mise in the terminal"
		info "mise: run \`mise doctor\` to verify this is setup correctly"
		;;
	*)
		info "mise: run \`$install_path --help\` to get started"
		;;
	esac
}

install_mise
after_finish_help
